from . import db, ModelBase, View
from backend.utils.misc import ArrayType
import enum
from sqlalchemy import Enum


class CardType(str, enum.Enum):
    TEXT = "TEXT"
    MARKDOWN = "MARKDOWN"
    LIST = "LIST"
    LINK = "LINK"
    IFRAME = "IFRAME"
    KPI = "KPI"
    IMAGE = "IMAGE"


class Card(ModelBase):
    __tablename_base__ = "card"

    id = db.Column(db.Integer, primary_key=True, autoincrement=True)
    view_id = db.Column(db.Integer, db.ForeignKey(View.id, ondelete="CASCADE"), nullable=False)

    name = db.Column(db.Text, nullable=False)
    type = db.Column(Enum(CardType), nullable=False)
    data_columns = db.relationship("DataColumn", cascade="all,delete-orphan", backref="card")
    priority = db.Column(db.Integer, default=50)
