from . import db, ModelBase, Card
import enum
from sqlalchemy import Enum


class DataColumnLabelType(str, enum.Enum):
    CONSTANT = "CONSTANT"
    COLUMN = "COLUMN"


class DataColumn(ModelBase):
    __tablename_base__ = "data_column"

    card_id: int = db.Column(db.Integer, db.ForeignKey(Card.id, ondelete="CASCADE"), primary_key=True, nullable=False)
    name: str = db.Column(db.String(64), primary_key=True, nullable=False)

    label: str = db.Column(db.String(64), nullable=True)
    label_type: DataColumnLabelType = db.Column(
        Enum(DataColumnLabelType), nullable=False, default=DataColumnLabelType.CONSTANT
    )

    priority: int = db.Column(db.Integer, nullable=False)


class FedDataColumn:
    def __init__(self, data_column: DataColumn, value: str, label_value: str):
        self.data_column: DataColumn = data_column
        self.value: str = value
        self.label_value: str = label_value

    def __repr__(self):
        return f"{self.data_column.name}<value={self.value}, label={self.label_value}>"

    def __str__(self):
        return f"{self.data_column.name}<value={self.value}, label={self.label_value}>"
