from flask import Blueprint, jsonify
from backend.utils.dataiku_api import dataiku_api

dataiku = Blueprint("dataiku", __name__, url_prefix="/dataiku")


@dataiku.route("/list-datasets", methods=["GET"])
def list_datasets():
    return jsonify({"datasets": dataiku_api.list_datasets_summary()})


@dataiku.route("/<dataset_name>/list-columns", methods=["GET"])
def list_columns(dataset_name):
    return jsonify({"columns": dataiku_api.list_columns(dataset_name)})


@dataiku.route("/<dataset_name>/status", methods=["GET"])
def get_dataset_status(dataset_name):
    return jsonify({"status": dataiku_api.get_dataset_status(dataset_name).name})


@dataiku.route("/plugin-settings", methods=["GET"])
def get_plugin_settings():
    return jsonify({"plugin_settings": dataiku_api.public_plugin_config})
