from marshmallow import fields
from backend.models.url_rule import UrlRuleMatchingType, UrlRuleMode
from backend.models import UrlRule
from marshmallow_sqlalchemy import auto_field
from marshmallow_enum import EnumField
from backend.schemas import BaseSchema


class UrlRuleSchema(BaseSchema):
    class Meta:
        model = UrlRule
        load_instance = True

    id = auto_field()
    view_id = auto_field()

    mode = EnumField(UrlRuleMode, allow_none=False)
    matching_type = EnumField(UrlRuleMatchingType, allow_none=False)
    priority = fields.Integer(allow_none=False)
    value = fields.String(allow_none=True)
    css_selectors = fields.List(fields.String)
