from marshmallow import fields
from marshmallow.validate import Length
from backend.models import View
from marshmallow_sqlalchemy import auto_field
from backend.schemas import BaseSchema


class ViewSchema(BaseSchema):
    class Meta:
        model = View
        load_instance = True

    id = auto_field()

    connection = fields.Nested("ConnectionSchema", only=("id",))
    cards = fields.Nested("CardSchema", many=True, only=("id",))
    url_rules = fields.Nested("UrlRuleSchema", many=True, only=("id", "mode"))

    name = fields.String(validate=Length(min=1), allow_none=False)
    description = fields.String(allow_none=True)
    is_active = fields.Boolean(default=True, allow_none=False)
